



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java日志工具之SLF4J</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java日志工具之SLF4J</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-19 08:43:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>SLF4J全称为Simple Logging Facade for Java (简单日志门面)，作为各种日志框架的简单门面或者抽象，包括 java.util.logging, log4j, logback. SLF4J允许用户在部署期间加入自己希望使用的日志系统。其实SLF4J与log4j, logback都是同一作者。</p>
<p>首先声明本文是基于SLF4J版本：<a href="http://www.slf4j.org/download.html" rel="external nofollow noreferrer">slf4j-1.7.6</a>。</p>
<p><strong>Hello World</strong></p>
<p>依照编程传统，先来一个Hello Word的Demo:</p>
<div>
<pre class="prettyprint linenums">package net.oseye;

import org.slf4j.Logger;<br />
import org.slf4j.LoggerFactory;

public class RunMain {

	public static void main(String[] args) {<br />
		Logger logger = LoggerFactory.getLogger(RunMain.class);<br />
		logger.info("Hello World");<br />
	}<br />
}</pre>
</div>
<p>首先需要下载slf4j依赖包,解压后将 slf4j-api-1.7.6.jar加入classpath中。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/484310/201507/040808252704400.gif" /></p>
<p>运行这个Demo会显示如下信息：</p>
<blockquote><p>SLF4J: Failed to load class "org.slf4j.impl.StaticLoggerBinder".<br />
SLF4J: Defaulting to no-operation (NOP) logger implementation<br />
SLF4J: See http://www.slf4j.org/codes.html#StaticLoggerBinder for further details.</p></blockquote>
<p>出现这个警告信息的原因是，slf4j没有与任何日志框(如：java.util.logging, log4j, logback)架绑定，一旦将某个绑定加入classpath中，这个警告消息就不再出现。假设你将slf4j-simple-1.7.2.jar(在下载的SLF4J的压缩包里)加入你的classpath，SLF4J自动动绑定SimpleLogger，这是输出：</p>
<blockquote><p>[main] INFO net.oseye.RunMain - Hello World</p></blockquote>
<p>但不能把多个绑定加入你的classpath，比如你再把slf4j-nop-1.7.6.jar加入classpath，就会看到如下的警告：</p>
<blockquote><p>SLF4J: Class path contains multiple SLF4J bindings.<br />
SLF4J: Found binding in [jar:file:/D:/Java/tools/slf4j-1.7.6/slf4j-simple-1.7.6.jar!/org/slf4j/impl/StaticLoggerBinder.class]<br />
SLF4J: Found binding in [jar:file:/D:/Java/tools/slf4j-1.7.6/slf4j-nop-1.7.6.jar!/org/slf4j/impl/StaticLoggerBinder.class]<br />
SLF4J: See http://www.slf4j.org/codes.html#multiple_bindings for an explanation.<br />
SLF4J: Actual binding is of type [org.slf4j.impl.SimpleLoggerFactory]<br />
[main] INFO net.oseye.RunMain - Hello World</p></blockquote>
<p>可以看到有多个绑定是会警告，且提醒你实际绑定的是哪个。</p>
<p><strong>绑定实现</strong></p>
<p>SLF4J与日志框架进行绑定是在编译阶段实现的，只要把与日志框架相应的绑定实现加入classpath中即可，SLF4J压缩包里已经有了一些绑定实现：</p>
<ul><li>slf4j-log4j12-1.7.2.jar：用于绑定 1.2版的log4j , 这是一个广泛使用的日志系统，当然你还要把log4j包加到classpath中</li>
<li>slf4j-jdk14-1.7.2.jar：用于绑定 java.util.logging, 作为JDK 1.4 的logging</li>
<li>slf4j-nop-1.7.2.jar：用于绑定 NOP, 不做任何操作.</li>
<li>slf4j-simple-1.7.2.jar：用于绑定 simple 的实现, 所有的打印会响应到 System.err. 只有INFO或者更高的级别会被打印. 这个绑定在小型应用中非常有用。</li>
<li>slf4j-jcl-1.7.2.jar：用于绑定 Jakarta Commons Logging. 这个绑定会使得SLF4J 的日志功能委托JCL来完成.</li>
<li>还有除了SLF4J项目以外提供的绑定包，例如 logback 本身就实现了SLF4J。Logback的 ch.qos.logback.classic.Logger 类实直接实现了SLF4J 的 org.slf4j.Logger 接口。因此，结合logback使用 SLF4J 节省很多内存和计算的开销。</li></ul>
<p>要切换日志系统，只需在classpath上替换slf4j的绑定则可，但只能添加一个绑定实现哦。但如果你使用log4j，不进要把绑定实现加入classpath，同时也要把log4j-x.x.x.jar包加入。</p>
<p>通过官方的一张图，来看看SLF4J最新机制吧：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/484310/201507/040808516206650.gif" /></p>
<ul><li>underlying表示直接实现SLF4J的接口，adaptation表示通过适配器实现SLF4J的接口；</li>
<li>SLF4J的接口和它的各种适配器是非常简单的。因为SLF4J没有使用或者说没有直接访问类加载器，所以SLF4J没有类加载器和内存泄露的问题，在方面，common logging就相形见拙了；</li></ul>
<p><strong>Maven依赖配置</strong></p>
<p>使用Maven构建项目时，在POM中添加依赖可以只声明绑定实现即可，通过依赖关系会自动把相应的SLF4J的版本加载到你的项目中，但及时你声明了SLF4J的依赖也没错，避免使用默认的SLF4J的版本不如你意。</p>
<ul><li>LOG4J :如果你希望使用log4j 作为日志框架。你只需在pom.xml文件中声明"org.slf4j:slf4j-log4j12"依赖（如下所示）。此外，slf4j-log4j12-1.7.2.jar, 依赖会自动把slf4j-api-1.7.2.jar加载到你的项目。不过明确的声明slf4j-api-1.7.2.jar的依赖并没有错，也避免MAVEN默认的相关版本信息不如你所意。下同。</p>
<div>
<pre class="prettyprint linenums">&lt;dependency&gt;<br />
  &lt;groupId&gt;org.slf4j&lt;/groupId&gt;<br />
  &lt;artifactId&gt;slf4j-log4j12&lt;/artifactId&gt;<br />
  &lt;version&gt;1.7.6&lt;/version&gt;<br />
&lt;/dependency&gt;</pre>
</div></li>
<li>LOGBACK-CLASSIC
<div>
<pre class="prettyprint linenums">&lt;dependency&gt;<br />
  &lt;groupId&gt;ch.qos.logback&lt;/groupId&gt;<br />
  &lt;artifactId&gt;logback-classic&lt;/artifactId&gt;<br />
  &lt;version&gt;1.0.13&lt;/version&gt;<br />
&lt;/dependency&gt;</pre>
</div></li>
<li>JAVA.UTIL.LOGGING
<div>
<pre class="prettyprint linenums">&lt;dependency&gt;<br />
  &lt;groupId&gt;org.slf4j&lt;/groupId&gt;<br />
  &lt;artifactId&gt;slf4j-jdk14&lt;/artifactId&gt;<br />
  &lt;version&gt;1.7.6&lt;/version&gt;<br />
&lt;/dependency&gt;</pre>
</div></li></ul>
<p><strong>线程映射表（Mapped Diagnostic Context）</strong></p>
<p>MDC本质上是日志框架维护的一个map，在应用中提供键值对，这些值可以添加到日志消息中。</p>
<p>SLF4J支持MDC。如果具体的日志框架提供了MDC功能，那么SLF4J就会委托下面的日志框架实现MDC功能。注意，现在只有log4j和logback提供MDC功能。如果具体的日志框架不提供，如java.util.logging，则slf4j将会存储MDC的数据，但是里面的信息需要用户通过代码来获得。</p>
<p>因此，作为一个SLF4J的用户，你可以利用已有MDC功能的log4j和logback，但是不能强制用户依赖具体的日志框架。</p>
<p>更多关于MDC的信息，<a href="http://logback.qos.ch/manual/mdc.html" rel="external nofollow noreferrer">请查看logback指南中的 MDC 章节</a>。</p>
<p><strong><br />
SLF4J经典应用：占位符</strong></p>
<p>SLF4J的日志消息使用占位符"{}"代替了常用的字符串拼接，据官方说这样速度更快：</p>
<div>
<pre class="prettyprint linenums">package net.oseye;

import org.slf4j.Logger;<br />
import org.slf4j.LoggerFactory;

public class RunMain {

	public static void main(String[] args) {<br />
		Logger logger = LoggerFactory.getLogger(RunMain.class);<br />
		logger.info("Hello {}","World");<br />
	}<br />
}</pre>
</div>
<ul><li>匹配：占位符&ldquo;{}&rdquo;，只匹配&ldquo;{&rdquo;后紧跟&ldquo;}&rdquo;的占位符</p>
<div>
<pre class="prettyprint linenums">logger.debug("Set {1,2} differs from {}", "3");<br />
logger.debug("Set {1,2} differs from {{}}", "3");</pre>
</div>
<p>输出：</p>
<blockquote><p>Set {1,2} differs from 3<br />
Set {1,2} differs from {3}</p></blockquote></li>
<li>转义：只要转义&ldquo;{&rdquo;即可
<div>
<pre class="prettyprint linenums">logger.debug("Set \\{} differs from {}", "3");<br />
logger.debug("File name is C:\\\\{}.", "file.zip");</pre>
</div>
<p>输出：</p>
<blockquote><p>Set {} differs from 3<br />
File name is C:\file.zip</p></blockquote></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390d6zn8.html">CSS居中布局总结【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzopz9.html">html与css面试结合工作的总结难点</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ke06r8.html">QT学习之路--创建一个对话框</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9344on8.html">中值排序的java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/390wnwnq.html">Scrambled Polygon---poj2007（利用叉积排序）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oj4p39.html">vim查找&sol;替换字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12ol79.html">DevExpress控件使用小结  z</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydx51gq.html">c程序设计语言&lowbar;习题1-18&lowbar;删除输入流中每一行末尾的空格和制表符，并删除完全是空格的行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdpm238.html">oracle sqlldr控制文件模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgdegr8.html">getline与get函数的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkn1dv8.html">ps、top 、free查看用户资源信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj550x9.html">数据库基础&mdash;&mdash;（SQLserver）约束</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey3e3m9.html">【Ubuntu 16】安装net-snmp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj4xrg8.html">Windows下pycharm远程连接服务器调试-tensorflow无法加载问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwk0g9.html">MySQL增量订阅&amp;amp&semi;消费组件Canal POC</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoz06xq.html">一套代码小程序&amp;amp&semi;Web&amp;amp&semi;Native运行的探索05&mdash;&mdash;snabbdom</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpdjg8.html">20175226 2018-2019-2 《Java程序设计》第五周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me1dv0q.html">高可用Redis&lpar;十一&rpar;：使用redis-trib&period;rb工具搭建集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvlgkg8.html">DOM事件-调用函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyymr6dq.html">python 2&period;0 与 python 3&period;0 区别</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ey57oj9.html">CSS3 &colon;target伪类的理解与使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojvwllq.html">Selenium2（java）框架设计 九</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpd310q.html">2&period;5&period; Integer 16 、Integer 32、Integer 64（Core Data 应用程序实践指南）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpd1kvq.html">angular指令中，require和transclude同时设置为true时的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zm5ln9.html">easyui弹出窗关闭前调用确认窗口&comma;先关闭页面后调用弹出窗口</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj5mzk8.html">JSP编译为Java类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mel70oq.html">oracle存储过程返回结果集</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljnr2e9.html">HoloLens开发手记 - 开始使用Vuforia Getting started with Vuforia</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kp7309.html">Charlse 使用小记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj2o128.html">python中将两个list合并为字典</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
